#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class BreakdownController < ApplicationController

  helper ProjectHelper

  SECTION=Navigation::SECTION_PROJECT
  

  def measures
    @metric = select_metric(params[:metric_id], Metric::NCSS_NCSS)
    @project=Project.find(params[:id].to_i)
    selected_sids= params[:sid] || []
    selected_sids=selected_sids.map{|s|s.to_i}
    @breakdown = Breakdown.new(@project, @metric.key, selected_sids)
    @snapshot = @breakdown.snapshot    
  end
  
  def rules
    @metric = select_metric(params[:metric_id], Metric::RULES_MANDATORY_VIOLATIONS_COUNT)
    @project = Project.find(params[:id].to_i)
    @categ_id = (params[:categ_id] ? params[:categ_id].to_i : nil)
    @rule_id = params[:rule_id].to_i if params[:rule_id]
    selected_sids= params[:sid] || []
    selected_sids=selected_sids.map{|s|s.to_i}
    @breakdown = Breakdown.new(@project, @metric.key, selected_sids, @categ_id, @rule_id)
    @snapshot=@breakdown.snapshot
  end

  protected
  def select_metric(metric_key, default_key)
    metric=nil
    if metric_key
      metric=Metric::by_key(metric_key)
    end
    if metric.nil?
      metric=Metric::by_key(default_key)
    end
    metric
  end
  
  def select_subsnapshot(snapshot, sid)
    if sid
      snapshot.children.each do |subsnapshot|
        return subsnapshot if subsnapshot.id==sid.to_i
      end
    end
    nil
  end

  def array_to_hash_by_id(array)
    hash={}
    array.each do |s|
      hash[s.id]=s
    end
    hash
  end
end
