#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class PluginsController < ApplicationController

  SECTION=Navigation::SECTION_CONFIGURATION

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => ['update'], :redirect_to => { :action => :index }

  require_role Role::ADMIN

  def index
    @properties_by_plugin = {}
    @plugins = java_facade.getPlugins().sort {|p1,p2| p1.getName() <=> p2.getName()}
    @editable_properties = {}
    @plugins.each do |plugin|
      @editable_properties[plugin]=java_facade.getPluginEditableProperties(plugin)
    end
  end

  def update
    plugins = java_facade.getPlugins()
    plugins.each do |plugin|
      editable_properties=java_facade.getPluginEditableProperties(plugin)
      editable_properties.each do |editable_property|
        value=params[editable_property.key()]
        old_value=params['old_' + editable_property.key()]
        if (value != old_value)
          if (editable_property.defaultValue()==value) or value.blank?
            configuration.clearProperty(editable_property.key())
          else
            configuration.setProperty(editable_property.key(), value)
          end
        end
      end
    end
    flash[:notice] = 'Parameters updated.'
    redirect_to :action => 'index'
  end
end
