 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with Sonar; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #
include Java

class SetupController < ApplicationController
  skip_before_filter :check_database
  layout 'nonav'

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :setup_database ], :redirect_to => { :action => :index }
  
  NO_DATABASE_MODEL = -1
  
  def index
    if needs_setup?
      db_connected = ActiveRecord::Base.connected?
      @db_config = ActiveRecord::Base.configurations[ ENV['RAILS_ENV'] ];
      if db_connected
        render :template => "setup/form" 
      else 
        render :template => "setup/dbdown" 
      end
    else
      lock_database_current_version
      redirect_to home_url
    end
  end

  def setup_database
    if needs_setup?
	  ActiveRecord::Migrator.migrate(migrations_path)
      lock_database_current_version
      Java::OrgSonarCore::Application.getInstance().getContainer().getComponent(Java::OrgSonarCoreDatabase::OperationalDatabaseListener.java_class).start()
    end
    redirect_to home_url
  end
  
  protected
  
  def lock_database_current_version
    $db_current_version = load_current_database_version if not $db_current_version
  end
  
  def needs_setup?
    @current_database_version = load_current_database_version
    @last_database_version = load_expected_database_version
    return @last_database_version > @current_database_version
  end
end
