#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
include ActionView::Helpers::JavaScriptHelper

class SnapshotSource < ActiveRecord::Base
  belongs_to :snapshot

  def to_hash_json
    json = {}
    if snapshot and snapshot.project
      json['key'] = snapshot.project.kee
      json['name'] = snapshot.project.name
      lines = []
      encoded_data(true).split("\n").each_with_index do |value, id|
        line = {:value => value, :id => id+1}
        lines << line
      end
      json['lines'] = lines if !lines.empty?
    end
    json
  end

  def encoded_data(escape_html=false)
    escape_html ? CGI::escapeHTML(data) : data
  end
  
  def to_xml()
    xml = Builder::XmlMarkup.new
    xml.sources do
      if snapshot and snapshot.project
        xml.source do
          xml.key(snapshot.project.kee)
          xml.name(snapshot.project.name)
          encoded_data(false).split("\n").each_with_index do |value, id|
            xml.line do
              xml.id(id+1)
              xml.value(value)
            end
          end
        end
      end
    end
  end

end
