 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with {library}; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #
class CreateUsersAndRoles < ActiveRecord::Migration
  def self.up
    create_users
    create_roles
  end

  def self.down
    drop_table 'users'
    drop_table 'roles'
    drop_table 'roles_users'
  end
  
  private 
  
  def self.create_users
    create_table 'users', :force => true do |t|
      t.column :login,                     :string, :limit => 40
      t.column :email,                     :string, :limit => 100
      t.column :crypted_password,          :string, :limit => 40
      t.column :salt,                      :string, :limit => 40
      t.column :created_at,                :datetime
      t.column :updated_at,                :datetime
      t.column :remember_token,            :string
      t.column :remember_token_expires_at, :datetime
    end
    
    User.create(:login => 'admin', :email => '', :password => 'admin',
      :password_confirmation => 'admin')    
  end
  
  def self.create_roles
    create_table 'roles' do |t|
      t.column :name, :string
    end
    
    # generate the join table
    create_table 'roles_users', :id => false do |t|
      t.column 'role_id', :integer
      t.column 'user_id', :integer
    end
    add_index 'roles_users', 'role_id'
    add_index 'roles_users', 'user_id'
    
     # Create admin role and assign it to the sonar user
    admin_role =  Role.find_or_create_by_name(Role::ADMIN)    
    user = User.find_by_login('admin')    
    user.roles<< admin_role     
  end
end
